IrreducibleIdealSplitter Class Reference

`#include <IrreducibleIdealSplitter.h>`

Inheritance diagram for IrreducibleIdealSplitter:

## Public Member Functions

| IrreducibleIdealSplitter (BigTermConsumer &consumer)
| IrreducibleIdealSplitter (unique_ptr< BigTermConsumer > consumer)
virtual void | consumeRing (const VarNames &names)
| Tell the consumer which ring is being used.
virtual void | beginConsumingList ()
| Tell the consumer that the ideals that are consumed until the next call to doneConsumingList are to be considered as one list of ideals, rather than as a number of separate ideals.
virtual void | beginConsuming ()
| Tell the consumer to begin consuming an ideal.
virtual void | consume (const Term &term)
| Consume a term.
virtual void | consume (const Term &term, const TermTranslator &translator)
virtual void | consume (const vector< mpz_class > &term)
virtual void | doneConsuming ()
| Must be called once after each time beginConsuming has been called.
virtual void | doneConsumingList ()
| Must be called once after each time beginConsumingList has been called.
Public Member Functions inherited from BigTermConsumer
virtual | ~BigTermConsumer ()
virtual void | consume (const BigIdeal &ideal)
virtual void | consume (unique_ptr< BigIdeal > ideal)
void | beginConsuming (const VarNames &names)
Public Member Functions inherited from TermConsumer
virtual | ~TermConsumer ()
void | consume (const Ideal &ideal)
| This is a non-virtual utility method that calls the other methods to achieve its effect of calling beginConsuming, then consuming all generators, and then calling doneConsuming.

## Private Attributes

BigTermConsumer & | _consumer
unique_ptr< BigTermConsumer > | _consumerDeleter
Term | _tmp
vector< mpz_class > | _bigTmp
bool | _inList

## Detailed Description

Definition at line 25 of file IrreducibleIdealSplitter.h.

## Constructor & Destructor Documentation

## IrreducibleIdealSplitter() [1/2]

IrreducibleIdealSplitter::IrreducibleIdealSplitter | ( | BigTermConsumer & | consumer | ) |

Definition at line 23 of file IrreducibleIdealSplitter.cpp.

## IrreducibleIdealSplitter() [2/2]

IrreducibleIdealSplitter::IrreducibleIdealSplitter | ( | unique_ptr< BigTermConsumer > | consumer | ) |

Definition at line 29 of file IrreducibleIdealSplitter.cpp.

## Member Function Documentation

## beginConsuming()

void IrreducibleIdealSplitter::beginConsuming | ( |  | ) |

virtual

Tell the consumer to begin consuming an ideal.

It is required to call this method before calling consume().

Implements BigTermConsumer.

Definition at line 51 of file IrreducibleIdealSplitter.cpp.

## beginConsumingList()

void IrreducibleIdealSplitter::beginConsumingList | ( |  | ) |

virtual

Tell the consumer that the ideals that are consumed until the next call to doneConsumingList are to be considered as one list of ideals, rather than as a number of separate ideals.

The default implementation is to ignore this, but the consumer is free to do something special in this case. It is thus not in general required to call this method, but if you don't, make sure that every consumer that you want to use does what you want if you output more than a single ideal.

Reimplemented from TermConsumer.

Definition at line 45 of file IrreducibleIdealSplitter.cpp.

## consume() [1/3]

void IrreducibleIdealSplitter::consume | ( | const Term & | term | ) |

virtual

Consume a term.

Reimplemented from BigTermConsumer.

Definition at line 56 of file IrreducibleIdealSplitter.cpp.

## consume() [2/3]

void IrreducibleIdealSplitter::consume | ( | const Term & | term,
|  | const TermTranslator & | translator )

virtual

Implements BigTermConsumer.

Definition at line 73 of file IrreducibleIdealSplitter.cpp.

## consume() [3/3]

void IrreducibleIdealSplitter::consume | ( | const vector< mpz_class > & | term | ) |

virtual

Implements BigTermConsumer.

Definition at line 91 of file IrreducibleIdealSplitter.cpp.

## consumeRing()

void IrreducibleIdealSplitter::consumeRing | ( | const VarNames & | names | ) |

virtual

Tell the consumer which ring is being used.

Implements BigTermConsumer.

Definition at line 36 of file IrreducibleIdealSplitter.cpp.

## doneConsuming()

void IrreducibleIdealSplitter::doneConsuming | ( |  | ) |

virtual

Must be called once after each time beginConsuming has been called.

Implements BigTermConsumer.

Definition at line 108 of file IrreducibleIdealSplitter.cpp.

## doneConsumingList()

void IrreducibleIdealSplitter::doneConsumingList | ( |  | ) |

virtual

Must be called once after each time beginConsumingList has been called.

Reimplemented from TermConsumer.

Definition at line 113 of file IrreducibleIdealSplitter.cpp.

## Member Data Documentation

## _bigTmp

vector<mpz_class> IrreducibleIdealSplitter::_bigTmp

private

Definition at line 43 of file IrreducibleIdealSplitter.h.

## _consumer

BigTermConsumer& IrreducibleIdealSplitter::_consumer

private

Definition at line 40 of file IrreducibleIdealSplitter.h.

## _consumerDeleter

unique_ptr<BigTermConsumer> IrreducibleIdealSplitter::_consumerDeleter

private

Definition at line 41 of file IrreducibleIdealSplitter.h.

## _inList

bool IrreducibleIdealSplitter::_inList

private

Definition at line 44 of file IrreducibleIdealSplitter.h.

## _tmp

Term IrreducibleIdealSplitter::_tmp

private

Definition at line 42 of file IrreducibleIdealSplitter.h.

The documentation for this class was generated from the following files:

- src/IrreducibleIdealSplitter.h
- src/IrreducibleIdealSplitter.cpp